use utf8;
use strict;
use warnings FATAL => 'all';

package Xyzzy::Document::Config;

use Xyzzy::Spiffy -Base;

field 'templatedir', -init => 'die "TemplateDir not set\n"';
field 'fragmentdir', -init => 'die "FragmentDir not set\n"';
field 'contentdir', -init => 'die "ContentDir not set\n"';

sub set_templatedir {
	my $dir = $_[0];
	die "Missing argument to TemplateDir\n" unless defined $dir;
	stat $dir;
	warn "TemplateDir $dir doesn't exist\n" unless -e _;
	warn "TemplateDir $dir is not a directory\n" unless -d _;
	$self->templatedir($dir);
}

sub set_fragmentdir {
	my $dir = $_[0];
	die "Missing argument to FragmentDir\n" unless defined $dir;
	stat $dir;
	warn "FragmentDir $dir doesn't exist\n" unless -e _;
	warn "FragmentDir $dir is not a directory\n" unless -d _;
	$self->fragmentdir($dir);
}

sub set_contentdir {
	my $dir = $_[0];
	die "Missing argument to ContentDir\n" unless defined $dir;
	stat $dir;
	warn "ContentDir $dir doesn't exist\n" unless -e _;
	warn "ContentDir $dir is not a directory\n" unless -d _;
	$self->contentdir($dir);
}
